<template>
  <ul class="home-calendar-days">
    <li
      v-for="(item, key) in days"
      :key="key"
      :class="{ passed: item.passed, current: item.current, past: item.past }"
      @click="$emit('change', key)"
    >
      <div>
        <span>{{ item.date.format('dddd') }}</span>
        <b>{{ item.date.format('jD') }}</b>
        <i v-if="item.passed" class="ic-check" />
      </div>
    </li>
  </ul>
</template>

<script>
export default {
  model: {
    prop: 'date',
    event: 'change'
  },
  props: {
    date: { type: String, default: '' }
  },
  data() {
    return {}
  },
  computed: {
    days() {
      let now = this.$moment().startOf('day')
      let start = (this.date
        ? this.$moment(this.date)
        : this.$moment()
      ).startOf('week')

      let end = start.clone().endOf('week')
      let days = {}
      let plans = this.$store.getters['home/plans'] || {}

      while (start < end) {
        let formatted = start.format('YYYY-MM-DD')
        let plan = plans[formatted] || {}
        days[formatted] = {
          date: start.clone(),
          current: this.date === formatted,
          passed: plan.foodCalories > 0,
          past: start < now,
          plan
        }
        start = start.clone().add(1, 'day')
      }
      return days
    }
  },
  watch: {},
  created() {},
  mounted() {},
  methods: {}
}
</script>
